import errno
import os
import shutil
from bzrlib.branch import Branch

def clean_tree(unknowns=True, ignored=False):
    def deletables(tree):
        for subp in tree.extras():
            if tree.is_ignored(subp):
                if ignored:
                    yield tree.abspath(subp)
            else:
                if unknowns:
                    yield tree.abspath(subp)
    br = Branch('.')
    tree = br.working_tree()
    printed_once = False
    for path in deletables(tree):
        if not printed_once:
            print "deletings paths:"
            printed_once = True
        print ' ', path
        try:
            os.unlink(path)
        except OSError, e:
            if e.errno != errno.EISDIR:
                raise
            shutil.rmtree(path)
